.model tiny

.data?
picmask         byte    ?
bufofs          word    ?
buffer          byte    1024 dup (?)

.code
        .startup
        mov     [bufofs], offset buffer
        cli
        in      al, 21h
        mov     [picmask], al
        and     al, not (1 shl 2)
        out     21h, al
        push    es
        mov     ax, 350Ah
        int     21h
        mov     word ptr cs:[vector0A+0], bx
        mov     word ptr cs:[vector0A+2], es
        pop     es
        mov     ax, 250Ah
        mov     dx, offset isr0A
        int     21h
        sti
        mov     dx, 331h
        mov     al, 0FFh
        out     dx, al
@@:     cmp     [bufofs], offset buffer
        je      @b

        mov     al, 0ACh
        out     dx, al
        mov     ah, 0
        int     1Ah
        mov     si, cx
        mov     di, dx
@@:     mov     ah, 0
        int     1Ah
        sub     dx, di
        sbb     cx, si
        cmp     dx, 18
        jb      @b
        push    ds
        mov     ax, 250Ah
        lds     dx, cs:[vector0A]
        int     21h
        pop     ds
        cli
        mov     al, [picmask]
        out     21h, al
        sti
        mov     si, offset buffer
        mov     ah, 2
charLoop:
        lodsb
        dec     si
        shr     al, 1
        shr     al, 1
        shr     al, 1
        shr     al, 1
        add     al, '0'
        .if     al > '9'
          add   al, 7
        .endif
        mov     dl, al
        int     21h
        lodsb
        and     al, 0Fh
        add     al, '0'
        .if     al > '9'
          add   al, 7
        .endif
        mov     dl, al
        int     21h
        mov     dl, ' '
        int     21h
        cmp     si, [bufofs]
        jb      charLoop
        mov     ax, 4C00h
        int     21h

isr0A           proc
        push    ax
        push    dx
        push    di
        push    ds
        push    cs
        pop     ds
        mov     dx, 331h
        in      al, dx
        test    al, 80h
        jnz     notForUs
@@:     dec     dx
        in      al, dx
        mov     di, [bufofs]
        cld
        stosb
        inc     dx
        in      al, dx
        test    al, 80h
        jz      @b
        mov     [bufofs], di
        mov     al, 20h
        out     20h, al
        pop     ds
        pop     di
        pop     dx
        pop     ax
        iret
notForUs:
        pop     ds
        pop     di
        pop     dx
        pop     ax
        byte    0EAh
vector0A        dword   ?
isr0A           endp
        end
